#-*-coding:utf-8 -*-
#author:Mengmeng.liu
'''two steps: 1. find out the intensity point;
2.record the intensity of these points
'''
import os
import re
import cv2 as cv
import math
from PIL import Image
import numpy as np
import read_pixel_protocols as rp
import matplotlib.pyplot as plt


"""transfer the image to binary image and output the outline pixels of spots"""
def tirflocation(fileitem):
    image1 = cv.imread(fileitem,3)
    image2 = image1[:,:,1]
    thershold_below = 80 #rp.readpixel(image2,'step',0.85)
    thershold_upper = 160 #rp.readpixel(image2,'step',0.98)
    ret_below,binary_below = cv.threshold(image2,thershold_below,255,cv.THRESH_BINARY)
    ret_upper,binary_upper = cv.threshold(image2,thershold_upper,255,cv.THRESH_BINARY)
    contours_below,hierarchy_below = cv.findContours(binary_below\
    ,cv.RETR_EXTERNAL,cv.CHAIN_APPROX_NONE)
    contours_upper,hierarchy_upper = cv.findContours(binary_upper\
    ,cv.RETR_EXTERNAL,cv.CHAIN_APPROX_NONE)
    return image1,contours_below,contours_upper,np.shape(image2)

"""determine the color of spots"""
def locationcal(image1,contours):
    MaxG = []
    PointColor = []
    locationG = []
    C = []
    for i in range(len(contours)):
        A = contours[i].tolist()
        data_x = []
        data_y = []
        B = {}
        for j in range(len(A)):
            data_x.append(A[j][0][0])
            data_y.append(A[j][0][1])
        Y = []
        x_index = list(set(data_x))
        x_index.sort()
        y_index = list(set(data_y))
        y_index.sort()
        for i in x_index:
            c = data_x.index(i)
            r_data_x = list(reversed(data_x))
            c2 = len(data_x) - r_data_x.index(i)-1
            y_start = data_y[c]
            y_end = data_y[c2]
            if y_end >= y_start:
                Y.append(list(range(y_start, y_end + 1)))
            else:
                Y.append(list(range(y_end, y_start + 1)))
        sum = 0
        for i in range(len(Y)):
            sum += len(Y[i])
        B['x'] = x_index
        B['y'] = Y
        if (1 <= len(B['x'])<= 20) & (1 <= len(B['y']) <= 20):
            output = rp.readpixel(image1,B)
        else:
            output = []
        if (len(output) == 2):
            PointColor.append(output[0])
            locationG.append(output[1])
    return PointColor,locationG

"""start with data"""
target_path = '/Users/liumengmeng/Desktop/darkfield/'# input file
save_path =  '/Users/liumengmeng/Desktop/darkfield/'#output file
filelist = os.listdir(target_path)
ITEM = []
GREEN = []
YELLOW = []
RED = []
BRIGHTYELLOW = []
BACKLOC = []
itemlist = [x for x in filelist if re.match('te\d+.jpg',x)!= None] # the name rule
D_green = []
D_yellow = []
D_red = []
D_brightyellow = []

for i in range(len(itemlist)):
    item = itemlist[i]
    fileitem = os.path.join(target_path,item)

    image,a,b,size = tirflocation(fileitem)
    pointcolor_below,intensity= locationcal(image,a)
    pointcolor_upper,intensity_upper= locationcal(image,b)

    plt.rcParams['figure.figsize'] = (size[1]/50.0/1.54, size[0]/50.0/1.54) # the size of output image
    plt.axes(facecolor = 'black')
    for j in range(len(intensity_upper)):
        for i in range(len(intensity)):
            if (intensity_upper[j] == intensity[i]):
                pointcolor_upper[j] = []
                intensity_upper[j] = []
            else:
                continue
    Pointcolor_upper = []
    Intensity_upper = []
    for i in pointcolor_upper:
        if i != [] :
            Pointcolor_upper.append(i)
    for i in intensity_upper:
        if i != [] :
            Intensity_upper.append(i)

    Pointcolor_below = pointcolor_below + Pointcolor_upper
    Intensity = intensity + Intensity_upper

    list_green = []
    list_yellow = []
    list_red = []
    list_brightyellow = []

    for i in range(len(Pointcolor_below)):
        if (Pointcolor_below[i] == 'green'):
            plt.plot(Intensity[i][1],Intensity[i][0],'o',markerfacecolor = 'mediumblue',\
            markersize = 10,markeredgecolor = 'mediumblue')# the color, shape and size of output spot
            list_green.append(Intensity[i])
        elif (Pointcolor_below[i] == 'yellow'):
            plt.plot(Intensity[i][1],Intensity[i][0],'s',markerfacecolor = 'forestgreen',\
            markersize = 10,markeredgecolor = 'forestgreen')
            list_yellow.append(Intensity[i])
        elif (Pointcolor_below[i] == 'brightyellow'):
            plt.plot(Intensity[i][1],Intensity[i][0],'<',markerfacecolor = 'firebrick',\
            markersize = 10,markeredgecolor = 'firebrick')
            list_brightyellow.append(Intensity[i])
        elif (Pointcolor_below[i] == 'red'):
            list_red.append(Intensity[i])
            plt.plot(Intensity[i][1],Intensity[i][0],'r<',markersize = 10,\
            markeredgecolor = 'r')
    plt.axis([0,size[1],size[0],0])
    plt.xticks([])
    plt.yticks([])

    item = item.replace('.jpg','deal.jpg') # name the output image
    item2 = item.replace('jpg','csv') # name the output txt file
    ITEM.append(item)
    GREEN.append(str(len(list_green)))
    YELLOW.append(str(len(list_yellow)))
    RED.append(str(len(list_red)))
    BRIGHTYELLOW.append(str(len(list_brightyellow)))

    plt.savefig(os.path.join(save_path,item),bbox_inches = 'tight',pad_inches = 0.0)
    plt.close()

    with open(os.path.join(save_path,item2),'wb+') as f:
        f.write('hahaha')
        for i in list_green:
            f.write('\n' + 'green' + '\t' + str(i[0]) + '\t' + str(i[1]))
        for i in list_yellow:
            f.write('\n' + 'yellow' + '\t' + str(i[0])+ '\t' + str(i[1]))
        for i in list_red:
            f.write('\n' + 'red' + '\t' + str(i[0])+ '\t' + str(i[1]))
        for i in list_brightyellow:
            f.write('\n' + 'brightyellow' + '\t' + str(i[0])+ '\t' + str(i[1]))
        f.close()

"""write the output file"""
with open('/Users/liumengmeng/Desktop/darkfield/result.csv','wb+') as f:
    f.write ('name' + '\t' + 'green' + '\t' + 'yellow' + '\t'
    + 'red' + '\t' + 'brightyellow' + '\n')
    for i in range(len(ITEM)):
        f.write(ITEM[i] + '\t' + GREEN[i] + '\t' + YELLOW[i] + '\t'
        + RED[i] + '\t' + BRIGHTYELLOW[i] + '\n')
        f.close
